// http://www.javacodegeeks.com/2013/05/parsing-xml-using-dom-sax-and-stax-parser-in-java.html#dom
package sax;

import java.io.File;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class PartySaxParser {

    public static void main(String[] args) throws Exception {
        SAXParserFactory parserFactory = SAXParserFactory.newInstance();
        SAXParser saxParser = parserFactory.newSAXParser();
        SAXHandler1 handler = new SAXHandler1();
      // saxParser.parse(ClassLoader.getSystemResourceAsStream("xml/party.xml"), handler);
        saxParser.parse(new File("party.xml"), handler);
    }
}

/**
 * The Handler for SAX Events.
 */
class SAXHandler1 extends DefaultHandler {
    private String content = null;
    @Override
    //Triggered when the start of tag is found.
    public void startElement(String uri, String localName,
            String elementName, Attributes attributes)
            throws SAXException {
        if (elementName.equals("party")) {
            System.out.println("Datum der Party: " + attributes.getValue("datum"));
        } else if (elementName.equals("gast")) {
            System.out.println("Neuer Gast: " + attributes.getValue("name"));
        } else if (elementName.equals("zustand")) {
            System.out.println("ist ledig: " + attributes.getValue("ledig") + " und nuechtern: " + attributes.getValue("nuechtern"));
        }
    }

    @Override
    public void endElement(String uri, String localName,
            String elementName) throws SAXException {
        if (elementName.equals("getraenk")) {
            System.out.println("trinkt: " + content);
        }
    }

    @Override
    public void characters(char[] ch, int start, int length)
            throws SAXException {
        content = String.copyValueOf(ch, start, length).trim();
    }

    @Override
    public void startDocument() throws SAXException {
        // compiled code
    }

    @Override
    public void endDocument() throws SAXException {
         // compiled code
    }

}
