package weitereBeispiele;

// StaxGetDataExample.java

import java.io.File;
import javax.xml.stream.*;
import javax.xml.transform.stream.StreamSource;

public class StaxGetDataExample
{
   public static void main( String[] args ) throws XMLStreamException
   {
      if( args.length != 5 ) {
         System.err.println( "Usage:" );
         System.err.println( "java ExampleStaxGetData <XmlFile> "
                           + "<ParentElem> <ChildElem> <FindText> <DataElem>" );
         System.err.println( "Example:" );
         System.err.println( "java ExampleStaxGetData MyXmlFile.xml "
                           + "Button Title \"Mein dritter Button\" Comment" );
         return;
      }
      XMLInputFactory inputFactory = XMLInputFactory.newInstance();
      XMLStreamReader stax = inputFactory.createXMLStreamReader( new StreamSource( new File( args[0] ) ) );
      StringBuffer    sb = new StringBuffer();
      int             state = 0;
      while( stax.hasNext() ) {
         stax.next();
         String  name = ( stax.hasName() ) ? stax.getName().getLocalPart().trim() : null;
         String  text = ( stax.hasText() ) ? stax.getText().trim() : null;
         boolean b1 = stax.hasName() && name.equals( args[1].trim() );   // <ParentElem>
         boolean b2 = stax.hasName() && name.equals( args[2].trim() );   // <ChildElem>
         boolean b3 = stax.hasText() && text.equals( args[3].trim() );   // <FindText>
         boolean b4 = stax.hasName() && name.equals( args[4].trim() );   // <DataElem>
         if( b1 && stax.isStartElement() ) state = 1;                    // <ParentElem>
         if( b1 && stax.isEndElement()   ) state = 0;
         if( state == 1 && b2 && stax.isStartElement() ) state = 2;      // <ChildElem>
         if( state == 2 && b2 && stax.isEndElement()   ) state = 1;
         if( state == 2 && b3 ) state = 3;                               // <FindText>
         if( state == 3 && b4 && stax.isStartElement() ) state = 4;      // <DataElem>
         if( state == 4 && b4 && stax.isEndElement()   ) break;
         if( state == 4 && stax.hasText() ) sb.append( stax.getText() ); // gesuchtes Ergebnis
      }
      System.out.println( sb );
   }
}