// schlechtes Beispiel 

package weitereBeispiele;

// StaxParseEvents.java

import java.util.*;
import javax.xml.stream.*;
import javax.xml.transform.stream.StreamSource;
import static javax.xml.stream.XMLStreamConstants.*;

public class StaxParseEvents
{
   public static void main( String[] args ) throws XMLStreamException
   {
      if( args.length != 1 ) {
         System.err.println( "Bitte XML-Datei angeben, beispielsweise:" );
         System.err.println( "      java StaxParseEvents MyXmlFile.xml" );
         return;
      }
      XMLInputFactory inputFactory = XMLInputFactory.newInstance();
      XMLStreamReader stax = inputFactory.createXMLStreamReader( new StreamSource( args[0] ) );
      Map<Integer,String> pem = (new StaxEventNames()).map;
      while( true ) {
         int pe = stax.getEventType();
         System.out.print( pe + "-" + pem.get( new Integer( pe ) ) );
         if( stax.hasName() ) {
            String s = ": ";
            if( stax.isEndElement() ) s += "/";
            s += stax.getName();
            if( stax.isStartElement() ) s += ":";
            System.out.print( s );
         }
         if( (pe == ATTRIBUTE || pe == START_ELEMENT) && stax.getAttributeCount() > 0 ) {
            for( int i = 0; i < stax.getAttributeCount(); i++ ) {
               System.out.print( " " + stax.getAttributeLocalName(i) + "=\""
                                     + stax.getAttributeValue(i) + "\"" );
            }
         }
         if( stax.hasText() ) System.out.print( ": " + stax.getText().trim() );
         System.out.println( "" );
         if( !stax.hasNext() ) break;
         stax.next();
      }
   }
}

class StaxEventNames
{
   public final Map<Integer,String> map;

   public StaxEventNames()
   {
      Map<Integer,String> pem = new HashMap<Integer,String>();
      pem.put( new Integer( ATTRIBUTE ),              "ATTRIBUTE     " );
      pem.put( new Integer( CDATA ),                  "CDATA         " );
      pem.put( new Integer( CHARACTERS ),             "CHARACTERS    " );
      pem.put( new Integer( COMMENT ),                "COMMENT       " );
      pem.put( new Integer( DTD ),                    "DTD           " );
      pem.put( new Integer( END_DOCUMENT ),           "END_DOCUMENT  " );
      pem.put( new Integer( END_ELEMENT ),            "END_ELEMENT   " );
      pem.put( new Integer( NAMESPACE ),              "NAMESPACE     " );
      pem.put( new Integer( SPACE ),                  "SPACE         " );
      pem.put( new Integer( START_DOCUMENT ),         "START_DOCUMENT" );
      pem.put( new Integer( START_ELEMENT ),          "START_ELEMENT " );
      pem.put( new Integer( ENTITY_DECLARATION ),     "ENTITY_DECLARATION    " );
      pem.put( new Integer( ENTITY_REFERENCE ),       "ENTITY_REFERENCE      " );
      pem.put( new Integer( NOTATION_DECLARATION ),   "NOTATION_DECLARATION  " );
      pem.put( new Integer( PROCESSING_INSTRUCTION ), "PROCESSING_INSTRUCTION" );
      map = Collections.unmodifiableMap( pem );
   }
}